/*
  A soros porton vett karaktereket az LCD kijelzon kiirja.
  16 karakter utani elso karakter vetele utan LCD-t torli,
  a sor elejerol ujra kezd irni. 
  1x16 karakteres kijelzo, bekotese:
  LCD kivezetés             Arduino panel kivezetés 
    1 (GND)                       GND 
    2 (Vcc)                       +5V 
    3 (Kontraszt)                 GND
    4 (RS - Register select)       D4 
    5 (R/W - Read/Write select)   GND
    6 (E - Enable)                 D5 
    7 (D0 - Data0)                  - 
    8 (D1 - Data1)                  - 
    9 (D2 - Data2)                  - 
   10 (D3 - Data3)                  - 
   11 (D4 - Data4)                 D6 
   12 (D5 - Data5)                 D7 
   13 (D6 - Data6)                 D8 
   14 (D7 - Data7)                 D9 
   15 (LED - Vcc)                   - 
   16 (LED - GND)                   -
 */

byte a = 0; // Az adott nyolcasban hanyadik karakter (elso=0)?
char b;     // Billentyuzott betu
byte em = 0;// Elso(0)/masodik(2) "sor" (8 karakter)
#include "LiquidCrystal.h" // A LiquidCrystal eljarast hasznaljuk
LiquidCrystal lcd(4, 5, 6, 7, 8, 9); // Az LCD bekotese labak
//szerint: RS(D4), E(D5), D4(D6) ,D5(D7), D6(D8), D7(D9)
 
void setup()        //Inicializalas
{
    lcd.begin(8, 2); //A hasznalt LCD 1 sor, 16 oszlopost igy kell definialni
    lcd.clear();     // LCD torlese
    Serial.begin(9600); // soros sebesseg 9600 Bd.
}   
void loop()        //Maga a foprogram
{
    	if (Serial.available())     //ha erkezett adat feldolgozasra
         { 
         if ((em == 0) & (a == 0)) lcd.clear(); //elso sor elso karaktere elott LCD torles           
	 b = Serial.read();      // 1 byte beolvasasa
         lcd.setCursor(a, em);   // ide kell irni az LCD-re: a.oszlop, em.sor (0 v.2)
         lcd.print(b);           // sorosan kuldott karakter kiirasa LCD-re
         a = a+1 ;               // a kovetkezo karakter ebbe az oszlopba (0-7) irodik
         if ((a == 8) && (em == 0)) //az elso "sor" utolso karaktere utan 
         {
         em = 2; a = 0;  //a masodik "sor" elso("0") karaktere kovetkezik
         }
       	 if ((a == 8) && (em == 2)) // a masodik sor utolso karaktere utan
         {
          em = 0; a = 0; // az elso sor elso ("0") karaktere kovetkezik
         }
     }
 }

